package pw.yumc.TeleportRandom;

import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

import cn.citycraft.PluginHelper.config.FileConfig;
import cn.citycraft.PluginHelper.utils.VersionChecker;

public class TeleportRandom extends JavaPlugin implements CommandExecutor {
    public final static Random rr = new Random();
    public static FileConfig config;

    private final Map<String, Long> cd = new HashMap<>();

    @Override
    public boolean onCommand(final CommandSender sender, final Command cmd, final String string, final String[] args) {
        try {
            if (sender instanceof Player) {
                final Player p = (Player) sender;
                if (!p.hasPermission("tpr.use")) {
                    sender.sendMessage(getPrefix() + config.getMessage("Message.NoPerm"));
                    return true;
                }
                switch (args.length) {
                case 0:
                    randomTP(0, p.getWorld(), p);
                    return true;
                case 1:
                    randomTP(Integer.parseInt(args[0]), p.getWorld(), p);
                    return true;
                case 2:
                    randomTP(Integer.parseInt(args[0]), Bukkit.getWorld(args[1]), p);
                    return true;
                }
            } else if (args.length > 1) {
                final Player p = Bukkit.getPlayer(args[0]);
                switch (args.length) {
                case 2:
                    randomTP(Integer.parseInt(args[1]), p.getWorld(), p);
                    return true;
                case 3:
                    randomTP(Integer.parseInt(args[1]), Bukkit.getWorld(args[2]), p);
                    return true;
                }
            }
        } catch (final IllegalArgumentException e) {
            sender.sendMessage(getPrefix() + "§c非法的参数或不存在的世界!");
        }
        if (args.length > 0) {
            if (args[0].equalsIgnoreCase("reload")) {
                config.reload();
                sender.sendMessage(getPrefix() + config.getMessage("Message.Reload"));
                return true;
            }
            if (args[0].equalsIgnoreCase("help")) {
                sender.sendMessage("玩家: /tpr [范围] [世界]");
                sender.sendMessage("控制台: /tpr <玩家> [范围] [世界]");
                return true;
            }
        }
        return false;
    }

    @Override
    public void onEnable() {
        getCommand("tpr").setExecutor(this);
        new VersionChecker(this);
    }

    @Override
    public void onLoad() {
        config = new FileConfig(this);
    }

    public void randomTP(final int limit, final World world, final Player p) {
        if (world == null || p == null) {
            throw new IllegalArgumentException();
        }
        getServer().getScheduler().runTaskAsynchronously(this, new Runnable() {
            @Override
            public void run() {
                final long t = System.currentTimeMillis();
                if (!p.hasPermission("tpr.nocd") && cd.keySet().contains(p.getName())) {
                    p.sendMessage(getPrefix() + config.getMessage("Message.CDs").replace("{0}", String.format("%0.2f", (t - cd.get(p.getName())) / 1000.00)));
                    return;
                }
                if (!config.getStringList("AllowWorld").contains(world.getName())) {
                    p.sendMessage(getPrefix() + config.getMessage("Message.NoPermWorld"));
                    return;
                }
                int lr = config.getInt("default");
                if (limit == 0) {
                    p.sendMessage(getPrefix() + config.getMessage("Message.default1"));
                    p.sendMessage(getPrefix() + config.getMessage("Message.default2"));
                } else {
                    lr = limit;
                    final int lrLimit = config.getInt("Limit");
                    if (lr > lrLimit) {
                        lr = lrLimit;
                        p.sendMessage(String.format(getPrefix() + config.getMessage("Message.Wran"), lrLimit));
                    }
                }
                final Point point = new Point(lr, world);
                getServer().getScheduler().runTask(TeleportRandom.this, new Runnable() {
                    @Override
                    public void run() {
                        checkBlock(point, p);
                        tp(point, p);
                    }
                });
                cd.put(p.getName(), t);
                getServer().getScheduler().runTaskLater(TeleportRandom.this, new Runnable() {
                    @Override
                    public void run() {
                        cd.remove(p.getName());
                    }
                }, config.getLong("CD"));
            }
        });
    }

    public void tp(final Point point, final Player p) {
        final Location loc = getTpLocation(point);
        p.teleport(loc);
        p.sendMessage(String.format(getPluginname() + config.getMessage("Message.Tip"), loc.getWorld().getName(), loc.getBlockX(), loc.getBlockY(), loc.getBlockZ()));
    }

    private void checkBlock(final Point point, final Player p) {
        final Material rbm = getBlock(point).getType();
        final String blockname = rbm.name();
        for (final String protectblock : config.getStringList("ProtectBlock")) {
            if (protectblock.equalsIgnoreCase(blockname)) {
                getBlock(point).setType(Material.GLASS);
                p.sendMessage(getPrefix() + config.getMessage("Message.Protect"));
                this.getServer().getScheduler().runTaskLater(this, new Runnable() {
                    @Override
                    public void run() {
                        getBlock(point).setType(rbm);
                    }
                }, 200);
            }
        }
    }

    private Block getBlock(final Point point) {
        return new Location(point.world, point.x, point.world.getHighestBlockYAt(point.x, point.z) - 1, point.z).getBlock();
    }

    private String getPluginname() {
        return config.getMessage("pluginname");
    }

    private String getPrefix() {
        return getServername() + getPluginname();
    }

    private String getServername() {
        return config.getMessage("servername");
    }

    private Location getTpLocation(final Point point) {
        return new Location(point.world, point.x, point.world.getHighestBlockYAt(point.x, point.z) + 3, point.z);
    }

    class Point {
        public int x;
        public int z;
        public int limit;
        public World world;

        public Point(final int limit, final World world) {
            this.limit = limit;
            this.world = world;
            x = rr.nextInt(limit);
            z = rr.nextInt(limit);
            final int xf = rr.nextInt(x);
            final int yf = rr.nextInt(z);
            if (xf % 2 != 0) {
                x = -x;
            }
            if (yf % 2 != 0) {
                z = -z;
            }
        }
    }
}
